<template lang="pug">
transition-group.vc-infinite-list(tag="div" :name="transition")
	template(v-for="(item, index) in internalList")
		.vc-infinite-list__item(:key="item.id" :class="itemClass")
			slot(name="item" 
				:item="item.item" 
				:set="createSetCallback(index)" 
				:delete="createDeleteCallback(index)" 
				:is-last="false"
				:id="item.id"
				:data="data"
				:index="index")

	.vc-infinite-list__item(v-if="!disabled" :key="count" :class="itemClass")
		slot(name="item" 
			:item="newItem" 
			:set="setNewItem" 
			:is-last="true"
			:data="data"
			:id="count"
			:index="internalList.length + 1")
</template>
<script lang="ts">
import Vue from 'vue';
import Component from 'vue-class-component';
import { equals } from 'ramda';

@Component<InifniteList>({
	props: {
		// The item to be generate when the list requires a new one
		item: [Function, Object],
		// Check if the item is empty (to be removed from the list)
		isItemEmpty: { type: Function, default: isItemEmptyDefault },
		// The item class
		itemClass: String,
		// The transition name to apply
		transition: { type: String, default: 'transition' },
		// Data to pass to the item slot
		data: Object,
		// Array of items
		value: Array,
		// Check if can create new items
		disabled: Boolean,
	},
	watch: {
		/// Everytime the internal-list changes, refresh its value
		internalList: {
			deep: true,
			handler() {
				this.refreshValue();
			},
		},
		// Set the initial value
		value: {
			immediate: true,
			handler(v) {
				this.setValue(v);
			},
		},
		// The new item
		newItem: {
			deep: true,
			handler(newItem) {
				if (!this.isItemEmpty(newItem)) {
					this.pushItem(newItem);
					this.newItem = this.createNewItem();
				}
			},
		},
	},
})
/**
 * Creates an infinite list. The list will grow as every item is being filled.
 */
export default class InifniteList extends Vue {
	// Props
	item!: () => unknown | unknown;
	isItemEmpty!: (item: unknown) => boolean;
	itemClass!: string;
	transition!: string;

	list: any[] = [];
	internalList: any[] = [];
	count = 0;
	newItem: any = this.createNewItem();

	/// Push a new item
	pushItem(item) {
		let id = this.count++;
		this.internalList.push({
			item,
			id: id,
		});
	}

	/// Push a new item
	setNewItem(item) {
		if (!this.isItemEmpty(item)) {
			this.pushItem(item);
			this.newItem = this.createNewItem();
			return;
		}
		this.newItem = item;
	}

	/// Create a new item
	createNewItem() {
		if (typeof this.item === 'function') {
			return this.item();
		} else if (!this.item) {
			return null;
		} else if (typeof this.item === 'object') {
			//@ts-ignore
			return { ...this.item };
		}
		return this.item;
	}

	/// Create a set callback
	createSetCallback(index) {
		return value => {
			if (!value || this.isItemEmpty(value)) {
				this.internalList.splice(index, 1);
				return;
			}
			const id = this.internalList[index].id;
			this.$set(this.internalList, index, { value, id });
		};
	}

	/// Create a delete callback
	createDeleteCallback(index) {
		return () => {
			this.internalList.splice(index, 1);
		};
	}

	/// Refresh the value of the list
	refreshValue() {
		for (let i = this.internalList.length - 1; i >= 0; --i) {
			if (this.isItemEmpty(this.internalList[i].item)) {
				this.internalList.splice(i, 1);
			}
		}
		this.list = this.internalList.map(i => i.item);
		this.$emit('input', this.list);
	}

	/// Set the value of the list
	setValue(value) {
		if (value === this.list) return;
		if (!value || !Array.isArray(value)) {
			this.count = 0;
			this.internalList = [];
		} else {
			const list: any[] = [];
			for (let i = 0; i < value.length; ++i) {
				list.push({
					item: value[i],
					id: i,
				});
			}
			this.count = list.length;
			this.internalList = list;
		}
	}
}

// Default validate for item
function isItemEmptyDefault(item) {
	if (!item) return true;
	if (typeof item === 'object') {
		for (const key in item) {
			const value = item[key];
			if (value) return false;
		}
	}
	return true;
}
</script>
<style lang="scss" scoped>
.vc-infinite-list__item {
	&.transition-enter-active,
	&.transition-leave-active {
		transition: transform 0.3s, opacity 0.15s;
		transform-origin: center center;
	}
	&.transition-enter,
	&.transition-leave-to {
		opacity: 0;
		transform: scale(1, 0.8);
	}
}
</style>
